#include "led_setting.h"

 extern uint8_t data_layer01[36];
 extern uint8_t data_layer02[36];
 extern uint8_t data_layer03[36];
 extern uint8_t data_layer04[36];

//Rcksetzen oder Initialisieren aller Layer
uint8_t reset_layers()
  {
    uint8_t i = 0;
    uint8_t n = 36;
    for (i=0 ; i<n; i++)
      {
//        data_layer01[i]= data_layer01[i] & 0x00; //Layer 1 reset
  //      data_layer02[i]= data_layer02[i] & 0x00; //Layer 2 reset
    //   data_layer03[i]= data_layer03[i] & 0x00; //Layer 3 reset
      // data_layer04[i]= data_layer04[i] & 0x00; //Layer 4 reset
        
       
       data_layer01[i]= data_layer01[i] | 0x99; //Layer 1 set
       data_layer02[i]= data_layer02[i] | 0x99; //Layer 2 set
       data_layer03[i]= data_layer03[i] | 0x99; //Layer 3 set
       data_layer04[i]= data_layer04[i] | 0x99; //Layer 4 set
      }
    return 1; 
  }

//LED in Layer setzen (aufgerufen durch LED setzen)
//Parameter: LED-Nr. (led), Farbe (colour), Zeiger auf Feld (*data)
uint8_t set_led_in_layer(uint16_t led, uint8_t colour, uint8_t *data)
  {
    //led = 15 - led; // LED-Nr. spiegeln fr MSB first
    uint16_t n = (15 - led) * 3 / 4; // zugehriges Byte bestimmen (4 LEDs (je 6 bit) = 3 Byte (je 8 bit) => 16 LEDs = 12 Byte)
    switch (colour) // Byte-Nr. fr Farbe bestimmen
      {
      case 0x01: //blue
        n = n;
        break;
      case 0x02: //green 
        n = n + 12;
        break;
      case 0x04: //red 
        n = n + 24;
        break;
      }
          
    switch (led % 4) 
      {
      case 0: // Byte 2,5,8,11 etc.
        data[n]   = (data[n]   | 0x3F);
        break;
      case 1: // Byte 1+2,4+5,7+8,10+11 etc.
        data[n]   = (data[n]   | 0x0F);
        data[n+1] = (data[n+1] | 0xC0);
        break;        
      case 2: // Byte 0+1,3+4,6+7,9+10 etc.
        data[n]   = (data[n]   | 0x03);
        data[n+1] = (data[n+1] | 0xF0);
        break;
      case 3: // Byte 0,3,6,9 etc.
        data[n]   = (data[n]   | 0xFC);
        break;        
      }
    return 1;
  }

//LED setzen
//Parameter: LED-Nr. (led), Farbe (colour)
uint8_t set_led(uint16_t led, uint8_t colour)
  {
    if (             led < 16) //LED in Layer 1
      {
      set_led_in_layer(led, colour, &data_layer01[0]);
      }
    if (led >= 16 && led < 32) //LED in Layer 2
      {
      set_led_in_layer(led-16, colour, &data_layer02[0]);
      }
    if (led >= 32 && led < 48) //LED in Layer 3
      {
      set_led_in_layer(led-32, colour, &data_layer03[0]);
      }     
    if (led >= 48 && led < 64) //LED in Layer 4
      {
      set_led_in_layer(led-48, colour, &data_layer04[0]);
      }      
    return 1;
  }
