/*
*******************************************************************************
* Copyright(C) 2010, 2011 Renesas Electronics Corporation
* RENESAS ELECTRONICS CONFIDENTIAL AND PROPRIETARY
* This program must be used solely for the purpose for which
* it was furnished by Renesas Electronics Corporation. No part of this
* program may be reproduced or disclosed to others, in any
* form, without the prior written permission of Renesas Electronics
* Corporation. 
*
* This device driver was created by Applilet3 for RL78/G13
* 16-Bit Single-Chip Microcontrollers
* Filename:	r_main.c
* Abstract:	This file implements main function.
* APIlib:	Applilet3 for RL78/G13 V1.01.00 [31 May 2011]
* Device:	R5F100LE
* Compiler:	IAR Systems iccrl78
* Creation date:	27.04.2015
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "led_setting.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"
#include "r_cg_timer.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Set option bytes */
#pragma location = "OPTBYTE"
__root const uint8_t opbyte0 = 0xEFU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte1 = 0xFFU;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte2 = 0xE8U;
#pragma location = "OPTBYTE"
__root const uint8_t opbyte3 = 0x84U;

/* Set security ID */
#pragma location = "SECUID"
__root const uint8_t secuid[10] = 
	{0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};
/* Start user code for global. Do not edit comment generated here */

/******************************************************************************
Exported global variables and functions (to be accessed by other files)
******************************************************************************/
uint8_t data_layer01[36];       /*Variablen Ebene 1 */
uint8_t data_layer02[36];       /*Variablen Ebene 2 */
uint8_t data_layer03[36];       /*Variablen Ebene 3 */
uint8_t data_layer04[36];       /*Variablen Ebene 4 */
uint8_t data_layer_test[4];   //Test array
uint8_t StatusFlag_Layer_index = 1; // Index fr Layer-Reihenfolge CSI-Ausgabe
uint8_t StatusFlag_CSI_enable = 0;  // Freigabe fr CSI-Ausgabe
uint8_t g_Uart0RxBuf[2];        /* UART0 receive buffer */
uint8_t g_Uart0RxErr;		/* UART0 receive error status */
MD_STATUS g_Uart0TxEnd;		/* UART0 transmission end */
volatile uint8_t StatusFlag_uart_Receive=0; //Status Flag Empfang von 2 Bytes

uint8_t Zustand_Clock = 1;

/* End user code. Do not edit comment generated here */
extern uint8_t _count;


/* End user code. Do not edit comment generated here */

/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
void  main(void)
{  
    // Treiber Clock rcksetzen  
   P3 &= ~(_01_Pn0_OUTPUT_1);
   
   //XLAT setzen  
P5 |= _01_Pn0_OUTPUT_1;
NOP();
//XLAT rcksetzen
P5 &= ~(_01_Pn0_OUTPUT_1); 
  /* LED Layer 0 initialisieren */
        reset_layers();
	/* UART0 receive buffer setting */
      //  Zustand_Clock=1;
	R_UART0_Receive(&g_Uart0RxBuf[0], 2);
        /* Start the UART0 Tx/Rx operation */
	R_UART0_Start();
        /* Start CSI Schnittstelle */
        //R_CSI11_Start();
        /* Statusflag CSi Setzen*/
        StatusFlag_CSI_enable = 1;
        //Test Array Fllen
        
        
        /*
        //Ebenen und LEDS auf 0 initialisieren
        reset_layers();
        // Treiber mit 0 durchschifften
         R_CSI11_Send(&data_layer01[0], 36);
         //Index wieder auf 1 
        */
        
        R_TAU0_Channel0_Start();
        
	while (1U)
	{
            if(StatusFlag_uart_Receive==1)
            {
            SRMK0 = 1U;			              /* Disable Reception Interrupt */
	    SREMK0 = 1U;		              /* Disable Reception error Interrupt */
                                                      /* Initialzustand setzen Ebenen 0 initialisieren */
              if (g_Uart0RxBuf[0]==88 && g_Uart0RxBuf[1] == 88)
              {                                       /*Michaels Funktion zum Rcksetzen der Ebenen */
               reset_layers();
               // R_UART0_Send(&data_layer01[0], 36);   /*Senden des Puffers */
               //R_UART0_Send(&data_layer02[0], 36);
               // R_UART0_Send(&data_layer03[0], 36);
               // R_UART0_Send(&data_layer04[0], 36);
                                                      /* Empfangspuffer wieder auf 0 setzen fr nchsten Empfang*/
               R_UART0_Receive(&g_Uart0RxBuf[0], 2);
               StatusFlag_uart_Receive=0;
                                                      /* Testweise Array senden */
               SRMK0 = 0U;		              /* Enable Reception Interrupt */
               SREMK0 = 0U;		              /* Enable Reception error Interrupt */
              }
                else
                {               
                                                      /* Call Michael Function */  
                set_led(g_Uart0RxBuf[0], g_Uart0RxBuf[1]);
                                                      /* Empfangspuffer wieder auf 0 setzen fr nchsten Empfang*/
                R_UART0_Receive(&g_Uart0RxBuf[0], 2);
                                                      /*Statusflag wieder auf Null setzten */
                StatusFlag_uart_Receive=0;
                                                     /* Testweise Array senden */
               // R_UART0_Send(&data_layer01[0], 36);
               // R_UART0_Send(&data_layer02[0], 36);
               // R_UART0_Send(&data_layer03[0], 36);
               // R_UART0_Send(&data_layer04[0], 36);
                SRMK0 = 0U;		             /* Enable Reception Interrupt */
                SREMK0 = 0U;		             /* Enable Reception error Interrupt */
                }
            
	    }
            
            //R_CSI10_Send(&data_layer_test[0], 4);
            
         //CSI-Ausgabe
          if (StatusFlag_CSI_enable == 1)
          {
            StatusFlag_CSI_enable = 0;
            switch(StatusFlag_Layer_index)
            {
            case 1:
              R_Timer_Send(&data_layer01[0], 36);
              break;
            case 2:
              R_Timer_Send(&data_layer02[0], 36);
              break;
            case 3:
              R_Timer_Send(&data_layer03[0], 36);
              break;
            case 4:
              R_Timer_Send(&data_layer04[0], 36);
              break;
            }
          } 
            
            
            
            
            
            
            

          } 
            
            
            
            
            
            

	/* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
