/*
*******************************************************************************
* Copyright(C) 2010, 2011 Renesas Electronics Corporation
* RENESAS ELECTRONICS CONFIDENTIAL AND PROPRIETARY
* This program must be used solely for the purpose for which
* it was furnished by Renesas Electronics Corporation. No part of this
* program may be reproduced or disclosed to others, in any
* form, without the prior written permission of Renesas Electronics
* Corporation. 
*
* This device driver was created by Applilet3 for RL78/G13
* 16-Bit Single-Chip Microcontrollers
* Filename:	r_timer_user.c
* Abstract:	This file implements device driver for TAU module.
* APIlib:	Applilet3 for RL78/G13 V1.01.00 [31 May 2011]
* Device:	R5F100LE
* Compiler:	IAR Systems iccrl78
* Creation date:	06.05.2015
*******************************************************************************
*/

/*
*******************************************************************************
** Include files
*******************************************************************************
*/
#include "r_cg_macrodriver.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"
#include "r_cg_port.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global. Do not edit comment generated here */
extern uint8_t Zustand_Clock;
extern uint8_t *gp_TimerTxAddress;
extern uint16_t g_TimerTxCnt_Byte;
extern uint16_t g_TimerTxCnt_Bit;
extern uint8_t StatusFlag_CSI_enable;
extern uint8_t StatusFlag_Layer_index;

uint8_t TimerTransmissionComplete=0;
/* End user code. Do not edit comment generated here */

/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**	This function is INTTM00 interrupt service routine.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**-----------------------------------------------------------------------------
*/
#pragma vector = INTTM00_vect
__interrupt void R_TAU0_Channel0_Interrupt(void)
{     

      if (Zustand_Clock==1) 
      {
        //Clock auf 1 setzen
        P3 |= (_01_Pn0_OUTPUT_1);  
        Zustand_Clock=0;

        
      }
      else  
      {
        //Clock auf 0 setzen
        P3 &= ~(_01_Pn0_OUTPUT_1);
        
      if (TimerTransmissionComplete==1)
      {
      TimerTransmissionComplete=0;
      TMMK00 = 1U;	/* disable INTTM00 interrupt */
      R_Timer_Callback_Send();
      }
      else
      {
        if (((*gp_TimerTxAddress) & (1 << g_TimerTxCnt_Bit))) //Datenabit auf SIN setzen
                {
                  P5 |= (_02_Pn1_OUTPUT_1); 

                }
                else
                {
                  P5 &= ~(_02_Pn1_OUTPUT_1); 

                }  
        if (g_TimerTxCnt_Bit>0)
        {
         g_TimerTxCnt_Bit--;

        }
        else 
        {
          g_TimerTxCnt_Bit=7;
          g_TimerTxCnt_Byte--;
          if(g_TimerTxCnt_Byte>=1)
          {  
            gp_TimerTxAddress++;

          }
          else
          {  
            
            TimerTransmissionComplete=1; // letztes Bit erreicht
           
            
            //TMMK00 = 1U;	/* disable INTTM00 interrupt */
            //TMIF00 = 0U;	/* clear INTTM00 interrupt flag */
            // R_TAU0_Channel0_Stop();
            //R_Timer_Callback_Send();
          }
        }
        
      }  
        
        
 
        Zustand_Clock=1;      
      }


	/* Start user code. Do not edit comment generated here */
    
	/* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
void R_Timer_Callback_Send(void)
{

/*USERCIDE*/
// Transistoren zurcksetzen  
P6 |= (_01_Pn0_OUTPUT_1 | _02_Pn1_OUTPUT_1 | _04_Pn2_OUTPUT_1 | _08_Pn3_OUTPUT_1);
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
//XLAT setzen  
P5 |= _01_Pn0_OUTPUT_1;
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();
NOP();

//for (uint8_t i =0; i<1000; i++){}

// zugehrigen Transistor setzen
switch (StatusFlag_Layer_index)
{
case 1:
  P6 &= ~(_01_Pn0_OUTPUT_1);
  break;
case 2:
  P6 &= ~(_02_Pn1_OUTPUT_1);
  break;
case 3:
  P6 &= ~(_04_Pn2_OUTPUT_1);
  break;
case 4:
  P6 &= ~(_08_Pn3_OUTPUT_1);
  break;
}

//XLAT rcksetzen
P5 &= ~(_01_Pn0_OUTPUT_1);  

// Layer-Index inkrementieren
StatusFlag_Layer_index++; 
if (StatusFlag_Layer_index >4) {StatusFlag_Layer_index=1;}

// CSI-Freigabe setzen
StatusFlag_CSI_enable = 1;
	/* End user code. Do not edit comment generated here */
}




/* End user code. Do not edit comment generated here */
